#
# Another example plugin for ADMLogger for unauthorized 'su' watching
# (This is VERY primitive, but gets the point across)
#
##PCONFIG BEGIN NORMAL N/A
##PCONFIG ANNOUNCE #############################################################################
##PCONFIG ANNOUNCE #   This file does not use pconfig, please read the README file for setup!  #
##PCONFIG ANNOUNCE #############################################################################
##PCONFIG END NORMAL
##PCONFIG STOP

package pam_unix;
use strict;
use Data::Dumper;

sub new {
    my ($logh, $mailh, $neth) = @_;
    my @regreq = ('su\(pam_unix\)');
    my $t = $logh -> register(\@regreq, 'pam_unix');
    print STDERR "PAM_UNIX REGISTRATION ERROR!!! $t\n" unless ($t eq '');
    my @OKLIST = ('me', 'theotherrootguy');
    my %OKUSERS;
    foreach (@OKLIST) {
        $OKUSERS{$_}++
    }
    return bless {
            'lh' => $logh,
            'mh' => $mailh,
            'nh' => $neth,
            'okusers' => \%OKUSERS
            }, 'pam_unix';
}

sub ready {
    my ($pkg) = @_;
    my $lh = $pkg->{'lh'};
    my $mh = $pkg->{'mh'};
    my $nh = $pkg->{'nh'};
    $mh -> setHTML(0); # We don't have HTML option
    my %OKUSERS = %{$pkg->{'okusers'}};
    my $date;
    chomp($date = `/bin/date +%m-%d-%Y`);
    my $host = `hostname`;
    chomp $host;
    my $mail_subject = "Unauthorized SU Report for -DATE- ($host)";
    if ($mail_subject =~ /(.*)-DATE-(.*)/) { $mail_subject = "$1$date$2"; };
    $mh->subject($mail_subject);
    MYLINES:
    foreach (@{$lh -> retrieve_condensed('pam_unix')}) {
        my $count = $$_[0];
        my $str = $$_[2];
        # su(pam_unix)[pid]: session opened for user root by username(uid=0)
        next MYLINES unless $str =~ /opened for user root by ([^(]+)/;
        next MYLINES if defined $OKUSERS{$1};
        $mh->append("$count attempt(s) by $1\n");
    } # my lines
    if ($mh -> isSendable()) {
        my $t = $mh->sendit();
        print STDERR "pam_unix: Message sending failed - $t\n" if ($t ne '');
    }
} # sub ready

1;

