#
# Another example plugin for ADMLogger for generic cleanup (total ignores)
#
##PCONFIG BEGIN NORMAL N/A
##PCONFIG ANNOUNCE #############################################################################
##PCONFIG ANNOUNCE #   This file does not use pconfig, please read the README file for setup!  #
##PCONFIG ANNOUNCE #############################################################################
##PCONFIG END NORMAL
##PCONFIG STOP

package zcleanup; # named zcleanup to run last
use strict;

sub new {
    my ($logh, $mailh, $neth) = @_;
    my $hostname = `hostname`;
    chomp($hostname);
    # WARNING! Any regex that matches these WILL BE DELETED
    my @regreq = (
      'syslogd [\d\.\-]+: restart',
      'syslog: syslogd startup succeeded',
      'syslog: syslogd shutdown succeeded',
      'syslog: klogd startup succeeded',
      'syslog: klogd shutdown succeeded',      
      'kernel: klogd [\d\.\-]+, log source =.*started',
      'kernel: Kernel logging \(proc\) stopped',
      'kernel: Kernel log daemon terminating',
      $hostname.' exiting on signal 15$',
      'kernel: Symbols match kernel version [\d\.]+\.',
      'kernel: Loaded \d+ symbols from /boot/',
      'kernel: Loaded \d+ symbols from \d+ modules',
      'kernel: Inspecting /boot/',
      'login\(pam_unix\)\[\d+\]: session'
      );
    my $t = $logh -> register(\@regreq, 'zcleanup');
    print STDERR "ZCLEANUP REGISTRATION ERROR!!! $t\n" unless ($t eq '');
    return bless {
            }, 'zcleanup';
}

sub ready {
    # We don't care - it just gets tossed.
} # sub ready

1;
